function [ output_args ] = SelectImgs(  )
%
%	Author: Shaohua Wan
%
%   1. Select a subset of images from the uiuc sport dataset.
%   2. Those images with an aspect ratio of 0.75 will be selected.
%   3. Those images that are selected will be resized to [stdrd_img_w,
%      stdrd_img_h].

stdrd_img_aspect_ratio = 0.75;
stdrd_img_w = 512;
stdrd_img_h = 384;

dirName = 'D:\Program\Matlab\MixedMemTopicModel\SpatialPyramid\images';

fileList = getAllFiles( dirName);


for i=1:size(fileList, 1)
    j = 1;
    filename = fileList{i};
    [pathstr, name, ext] = fileparts(filename);
    if(~strcmp(ext,'.jpg'))
        continue;
    end
    
    img = imread(filename);
    [img_h, img_w, img_chnl] = size(img);
    if( img_h<1000 && abs(img_w/img_h*stdrd_img_aspect_ratio-1)<0.05 )
        img = imresize(img, [stdrd_img_h, stdrd_img_w] );
    else
        discardedFileList{j} = filename;
        j = j+1;
        continue;
    end
   
    resized_file_dir = fullfile([pathstr, '_sel']);
    resized_file_name = fullfile([pathstr, '_sel'], [name ext]);
    if(~isdir(resized_file_dir))
        mkdir(resized_file_dir);
    end
    imwrite(img, resized_file_name);
    
end

save('discardedFileList.mat', 'discardedFileList')

end

